mcast4-queryfld05 6.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213
  1. #!/bin/sh
  2. ################################################################################
  3. ## ##
  4. ## Copyright (c) International Business Machines Corp., 2006 ##
  5. ## ##
  6. ## This program is free software; you can redistribute it and#or modify ##
  7. ## it under the terms of the GNU General Public License as published by ##
  8. ## the Free Software Foundation; either version 2 of the License, or ##
  9. ## (at your option) any later version. ##
  10. ## ##
  11. ## This program is distributed in the hope that it will be useful, but ##
  12. ## WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY ##
  13. ## or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License ##
  14. ## for more details. ##
  15. ## ##
  16. ## You should have received a copy of the GNU General Public License ##
  17. ## along with this program; if not, write to the Free Software ##
  18. ## Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA ##
  19. ## ##
  20. ## ##
  21. ################################################################################
  22. #
  23. # File:
  24. # mcast4-queryfld05
  25. #
  26. # Description:
  27. # Verify that the kernel is not crashed when joining joining plural IPv4
  28. # multicast groups on separate socket, then receiving a large number of
  29. # Multicast Address Specific Query
  30. #
  31. # Setup:
  32. # See testcases/network/stress/README
  33. #
  34. # Author:
  35. # Mitsuru Chinen <mitch@jp.ibm.com>
  36. #
  37. # History:
  38. # May 1 2006 - Created (Mitsuru Chinen)
  39. #
  40. #-----------------------------------------------------------------------
  41. # Uncomment line below for debug output.
  42. #trace_logic=${trace_logic:-"set -x"}
  43. $trace_logic
  44. # The test case ID, the test case count and the total number of test case
  45. TCID=mcast4-queryfld05
  46. TST_TOTAL=1
  47. TST_COUNT=1
  48. export TCID
  49. export TST_COUNT
  50. export TST_TOTAL
  51. # Make sure the value of LTPROOT
  52. LTPROOT=${LTPROOT:-`(cd ../../../../.. ; pwd)`}
  53. export LTPROOT
  54. # Check the environmanet variable
  55. . check_envval || exit $TST_TOTAL
  56. # Dulation of the test [sec]
  57. NS_DURATION=${NS_DURATION:-3600} # 1 hour
  58. # Number of the multicast to join
  59. MCASTNUM_NORMAL=${MCASTNUM_NORMAL:-20}
  60. # The number of the test link where tests run
  61. LINK_NUM=${LINK_NUM:-0}
  62. # Network portion of the IPv4 address
  63. NETWORK_PART=${IPV4_NETWORK:-"10.0.0"}
  64. # Netmask of the IPv4 network
  65. NETWORK_MASK=24
  66. # Host portion of the IPv4 address
  67. LHOST_HOST_PART=${LHOST_IPV4_HOST:-"2"} # local host
  68. RHOST_HOST_PART=${RHOST_IPV4_HOST:-"1"} # remote host
  69. # Prefix of the Multicast Address
  70. MCAST_ADDR_PREFIX=224.10
  71. #-----------------------------------------------------------------------
  72. #
  73. # Function: do_cleanup
  74. #
  75. # Description:
  76. # Recover the system configuration
  77. #
  78. #-----------------------------------------------------------------------
  79. do_cleanup()
  80. {
  81. # Make sure to kill the multicast receiver and sender
  82. killall -SIGHUP ns-mcast_join >/dev/null 2>&1
  83. $LTP_RSH $RHOST killall -SIGHUP ns-igmp_querier >/dev/null 2>&1
  84. # Clean up each interface
  85. initialize_if lhost ${LINK_NUM}
  86. initialize_if rhost ${LINK_NUM}
  87. }
  88. #-----------------------------------------------------------------------
  89. #
  90. # Function: do_setup
  91. #
  92. # Description:
  93. # Configure the ssystem for the test
  94. #
  95. #-----------------------------------------------------------------------
  96. do_setup()
  97. {
  98. # Initialize the system configuration
  99. do_cleanup
  100. # Call do_cleanup function before exit
  101. trap do_cleanup 0
  102. # name of interface of the local/remote host
  103. lhost_ifname=`get_ifname lhost $LINK_NUM`
  104. if [ $? -ne 0 ]; then
  105. tst_resm TBROK "Failed to get the interface name at the local host"
  106. exit $TST_TOTAL
  107. fi
  108. rhost_ifname=`get_ifname rhost $LINK_NUM`
  109. if [ $? -ne 0 ]; then
  110. tst_resm TBROK "Failed to get the interface name at the remote host"
  111. exit $TST_TOTAL
  112. fi
  113. # Set IPv4 addresses to the interfaces
  114. set_ipv4addr lhost $LINK_NUM $NETWORK_PART $LHOST_HOST_PART
  115. if [ $? -ne 0 ]; then
  116. tst_resm TBROK "Failed to add any IP address at the local host"
  117. exit 1
  118. fi
  119. set_ipv4addr rhost $LINK_NUM $NETWORK_PART $RHOST_HOST_PART
  120. if [ $? -ne 0 ]; then
  121. tst_resm TBROK "Failed to add any IP address at the remote host"
  122. exit 1
  123. fi
  124. # IPv4 address of the local/remote host
  125. lhost_addr="${NETWORK_PART}.${LHOST_HOST_PART}"
  126. rhost_addr="${NETWORK_PART}.${RHOST_HOST_PART}"
  127. # Make sure the connectvity
  128. check_icmpv4_connectivity $lhost_ifname $rhost_addr
  129. if [ $? -ne 0 ]; then
  130. tst_resm TBROK "There is no IPv4 connectivity."
  131. exit 1
  132. fi
  133. # Make sure the sysctl values
  134. sysctl -w net.ipv4.igmp_max_memberships=20 >/dev/null
  135. if [ $? -ne 0 ]; then
  136. tst_resm TBROK "Failed to set the sysctl value regarding multicast"
  137. exit $TST_TOTAL
  138. fi
  139. sysctl -w net.ipv4.igmp_max_msf=10 >/dev/null
  140. sysctl -w net.ipv4.conf.${lhost_ifname}.force_igmp_version=0 >/dev/null
  141. sysctl -w net.ipv4.conf.all.force_igmp_version=0 >/dev/null
  142. }
  143. #-----------------------------------------------------------------------
  144. #
  145. # Main
  146. #
  147. #
  148. # Test description
  149. tst_resm TINFO "Verify that the kernel is not crashed when joining $MCASTNUM_NORMAL IPv4 multicast groups on separate sockets, then receiving a large number of Multicast Address Specific Query in $NS_DURATION [sec]"
  150. do_setup
  151. # Run a multicast join tool
  152. ns-mcast_join -f 4 -I $lhost_ifname -n $MCASTNUM_NORMAL -p $MCAST_ADDR_PREFIX > /dev/null
  153. if [ $? -ne 0 ]; then
  154. tst_resm TBROK "Failed to start multicast joining tool Please check the environment"
  155. exit 1
  156. fi
  157. # Send IGMP Multicast Address Specific Query from the remote host
  158. querier_num=0
  159. while [ $querier_num -lt $MCASTNUM_NORMAL ]; do
  160. # Define the multicast address
  161. x=`expr $querier_num \/ 254`
  162. y=`expr $querier_num % 254 + 1`
  163. if [ $x -gt 254 ]; then
  164. tst_resm TINFO "The number of the connection is less than $querier_num"
  165. break
  166. fi
  167. mcast_addr=${MCAST_ADDR_PREFIX}.${x}.${y}
  168. $LTP_RSH $RHOST ${LTPROOT}/testcases/bin/ns-igmp_querier -I $rhost_ifname -m $mcast_addr -t $NS_DURATION -r 0 -b
  169. querier_num=`expr $querier_num + 1`
  170. done
  171. sleep $NS_DURATION
  172. #-----------------------------------------------------------------------
  173. #
  174. # Clean up
  175. #
  176. do_cleanup
  177. tst_resm TPASS "Test is finished successfully."
  178. exit 0